#include <stdio.h>
#include <wchar.h>
#include <windows.h>
#include <qedit.h>			// SampleGrabberp
#include <dshow.h>
#include "dscap.h"

int InitDirectShowCap( int camconf, strDirectShowCap *dsc, int *width, int *height )
// DirectShowɂUSBJ̎gp̍ۂ̏
{
    ULONG cFetched;
	HRESULT hr;	// UgR[h

	IEnumMoniker *pClassEnum;	// jJ񋓂邽߂ɎgpC^[tFCXB
	IMoniker *pMoniker = NULL;	// jJ IuWFNggpł悤ɂ郁\bh܂܂ꂽC^[tFCXB
	IBaseFilter *pbf = NULL, *pF = NULL;	// tB^𐧌䂷郁\bh񋟂B
	AM_MEDIA_TYPE amt, *pmtConfig;	// fBATṽtH[}bgLqB
	IAMStreamConfig *pConfig = NULL;	// rfILv`tB^̏o̓sɎB
	VIDEO_STREAM_CONFIG_CAPS scc;	// ͈͓̔̃rfI tH[}bgLqB

	CoInitialize( NULL );					// COM̏

	// ---- Lv`tB^̏ ----
	// Lv`foCXT
	// foCX񋓎q쐬
	dsc->pDevEnum = NULL;
	CoCreateInstance( CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC, IID_ICreateDevEnum, (void **)&(dsc->pDevEnum) );
	// rfILv`foCX񋓎q쐬
	pClassEnum = NULL;
	dsc->pDevEnum -> CreateClassEnumerator( CLSID_VideoInputDeviceCategory, &pClassEnum, 0 );
	if ( pClassEnum == NULL ) {	// Ȃ
		fprintf( stderr, "No video capture device\n" );
		dsc->pDevEnum->Release();
		CoUninitialize();
		return 0;
	}
	// ŏɌrfILv`foCX̃IuWFNg̃C^tF[X𓾂
	pClassEnum->Next( 1, &pMoniker, &cFetched );
	pMoniker->BindToObject( 0, 0, IID_IBaseFilter, (void **)&pbf );
	// ---- tB^Ot̏ ----
	// tB^OtAC^[tF[X𓾂
	CoCreateInstance( CLSID_FilterGraph, NULL, CLSCTX_INPROC, IID_IGraphBuilder, (void **)&(dsc->pGraph) );
	dsc->pGraph->QueryInterface( IID_IMediaControl, (LPVOID *)&(dsc->pMC) );
	// Lv`tB^tB^Otɒǉ
	dsc->pGraph->AddFilter( pbf, L"Video Capture" );
	// ---- OotB^̏ ----
	// OotB^
	CoCreateInstance( CLSID_SampleGrabber, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (LPVOID *)&pF );
	pF->QueryInterface( IID_ISampleGrabber, (void **)&(dsc->pGrab) );
	// OotB^̑}ꏊ̓̂߂̐ݒ
	ZeroMemory( &amt, sizeof(AM_MEDIA_TYPE) );
	amt.majortype  = MEDIATYPE_Video;
	amt.subtype    = MEDIASUBTYPE_RGB24;
	amt.formattype = FORMAT_VideoInfo; 
	dsc->pGrab -> SetMediaType( &amt );
	// OotB^tB^Otɒǉ
	dsc->pGraph -> AddFilter( pF, L"SamGra" );
	// ---- Lv`Ot̏ ----
	// Lv`Ot   
	CoCreateInstance( CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC, IID_ICaptureGraphBuilder2, (void **)&(dsc->pCapture) );
	dsc->pCapture -> FindInterface( &PIN_CATEGORY_CAPTURE , 0, pbf, IID_IAMStreamConfig, (void **)&pConfig );
	// 𑜓xύX
	hr = pConfig->GetStreamCaps( camconf, &pmtConfig, (BYTE *)&scc );	// w肳ꂽ̂ɕύX
	if ( hr != S_OK ) {
		fprintf( stderr, "Error : GetStreamCaps" );
		return 0;
	}
	hr = pConfig->SetFormat( pmtConfig );
	
	*width  = ((VIDEOINFOHEADER *)(pmtConfig->pbFormat))->bmiHeader.biWidth;
	*height = ((VIDEOINFOHEADER *)(pmtConfig->pbFormat))->bmiHeader.biHeight;
	// tB^OtLv`Otɑgݍ
	dsc->pCapture -> SetFiltergraph( dsc->pGraph );
	// Lv`Ot̐ݒAOo_Oo͂ɐݒ
	dsc->pCapture -> RenderStream( &PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video, pbf, NULL, pF );
	// Lv`tB^̎QƂ[X
    pbf -> Release();
	
	return 1;
}

int CheckDirectShowCap( void )
// DirectShowɂUSBJ̏̃`FbN
{
    ULONG cFetched;
	HRESULT hr;	// UgR[h

	IEnumMoniker *pClassEnum;	// jJ񋓂邽߂ɎgpC^[tFCXB
	IMoniker *pMoniker = NULL;	// jJ IuWFNggpł悤ɂ郁\bh܂܂ꂽC^[tFCXB
	IBaseFilter *pbf = NULL, *pF = NULL;	// tB^𐧌䂷郁\bh񋟂B
	AM_MEDIA_TYPE amt, *pmtConfig;	// fBATṽtH[}bgLqB
	IAMStreamConfig *pConfig = NULL;	// rfILv`tB^̏o̓sɎB
	VIDEO_STREAM_CONFIG_CAPS scc;	// ͈͓̔̃rfI tH[}bgLqB
	int i, picount, pisize;

	strDirectShowCap dsc0, *dsc;

	dsc = &dsc0;
	CoInitialize( NULL );					// COM̏

	// ---- Lv`tB^̏ ----
	// Lv`foCXT
	// foCX񋓎q쐬
	dsc->pDevEnum = NULL;
	hr = CoCreateInstance( CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC, IID_ICreateDevEnum, (void **)&(dsc->pDevEnum) );
	if ( FAILED( hr ) ) {
		fprintf( stderr, "Failed : CoCreateInstance\n" );
		return 0;
	}
	// rfILv`foCX񋓎q쐬
	pClassEnum = NULL;
	hr = dsc->pDevEnum -> CreateClassEnumerator( CLSID_VideoInputDeviceCategory, &pClassEnum, 0 );
	if ( FAILED( hr ) ) {
		fprintf( stderr, "Failed : CreateClassEnumerator\n" );
		return 0;
	}

	if ( pClassEnum == NULL ) {	// Ȃ
		fprintf( stderr, "No video capture device\n" );
		dsc->pDevEnum->Release();
		CoUninitialize();
		return 0;
	}
	pClassEnum->Reset();	// Zbg
	while ( pClassEnum->Next( 1, &pMoniker, &cFetched ) == S_OK ) {
		/*********** foCX擾 ***********/
		// get the device friendly name:
		IPropertyBag *pPropertyBag;
		TCHAR devname[128];
		// IPropertyBagbind
		pMoniker->BindToStorage( 0, 0, IID_IPropertyBag, (void **)&pPropertyBag );
		// Friendly name擾邽߂̓ꕨ
		VARIANT varFriendlyName;
		varFriendlyName.vt = VT_BSTR;
		// FriendlyName擾
		pPropertyBag->Read( L"FriendlyName", &varFriendlyName, 0 );
		// 擾FriendlyNameRs[
#ifdef UNICODE
		// ÔUNICODE̎̃R[h
		_tcscpy(devname, varFriendlyName.bstrVal);
#else
		// ɉȂ΁AUNICODEł͂ȂAɂȂ͂ł
		WideCharToMultiByte( CP_ACP, 0, varFriendlyName.bstrVal, -1, devname, sizeof(devname), 0, 0 );
#endif      
		// ʂ\
//		MessageBox(NULL, devname, "DEVICE NAME", MB_OK);
		printf( "%s\n", devname );
		// 
		VariantClear(&varFriendlyName);
		// 
		pMoniker->Release();
		pPropertyBag->Release();

		/*********** 𑜓x擾 ***********/
		pMoniker->BindToObject( 0, 0, IID_IBaseFilter, (void **)&pbf );
		// ---- tB^Ot̏ ----
		// tB^OtAC^[tF[X𓾂
		CoCreateInstance( CLSID_FilterGraph, NULL, CLSCTX_INPROC, IID_IGraphBuilder, (void **)&(dsc->pGraph) );
		dsc->pGraph->QueryInterface( IID_IMediaControl, (LPVOID *)&(dsc->pMC) );
		// Lv`tB^tB^Otɒǉ
		dsc->pGraph->AddFilter( pbf, L"Video Capture" );
		// ---- OotB^̏ ----
		// OotB^
		CoCreateInstance( CLSID_SampleGrabber, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (LPVOID *)&pF );
		pF->QueryInterface( IID_ISampleGrabber, (void **)&(dsc->pGrab) );
		// OotB^̑}ꏊ̓̂߂̐ݒ
		ZeroMemory( &amt, sizeof(AM_MEDIA_TYPE) );
		amt.majortype  = MEDIATYPE_Video;
		amt.subtype    = MEDIASUBTYPE_RGB24;
		amt.formattype = FORMAT_VideoInfo; 
		dsc->pGrab -> SetMediaType( &amt );
		// OotB^tB^Otɒǉ
		dsc->pGraph -> AddFilter( pF, L"SamGra" );
		// ---- Lv`Ot̏ ----
		// Lv`Ot   
		CoCreateInstance( CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC, IID_ICaptureGraphBuilder2, (void **)&(dsc->pCapture) );
		dsc->pCapture -> FindInterface( &PIN_CATEGORY_CAPTURE , 0, pbf, IID_IAMStreamConfig, (void **)&pConfig );
		hr = pConfig->GetNumberOfCapabilities( &picount, &pisize );
//		printf( "%d, %d\n", picount, pisize );
		for ( i = 0; i < picount; i++ ) {	// 𑜓x\
			pConfig->GetStreamCaps( i, &pmtConfig, (BYTE *)&scc );
			printf("%02d : %dx%d[%.1ffps]\n", i, ((VIDEOINFOHEADER *)(pmtConfig->pbFormat))->bmiHeader.biWidth, ((VIDEOINFOHEADER *)(pmtConfig->pbFormat))->bmiHeader.biHeight, 1/(((VIDEOINFOHEADER *)(pmtConfig->pbFormat))->AvgTimePerFrame*0.0000001) );
		}
		// Lv`tB^̎QƂ[X
	    pbf -> Release();
	}
	// 
	pClassEnum->Release();
	dsc->pDevEnum->Release();
	// COMI
	CoUninitialize();

	return 1;
}

int StartDirectShowCap( strDirectShowCap *dsc )
// DirectShowɂUSBJ̎gpJn
{
	HRESULT hr;
	
	// ---- Lv`Jn ----
	hr = dsc->pGrab -> SetBufferSamples(TRUE);	// OuJn
	hr = dsc->pMC -> Run();						// _OJn
	if ( hr == S_OK )	return 1;
	else	return 0;
}

int CaptureDirectShowCap( strDirectShowCap *dsc, unsigned char *buff, long buff_size )
// DirectShowɂUSBJpLv`
{
	HRESULT hr;

	hr = dsc->pGrab->GetCurrentBuffer( &buff_size, (long *)buff );	// obt@̃Rs[擾
	if ( hr == S_OK )	return 1;
	else	return 0;
}

int PauseDirectShowCap( strDirectShowCap *dsc )
// DirectShowɂUSBJ̎gpꎞ~
{
	HRESULT hr;
	
	hr = dsc->pMC -> Pause();
	if ( hr == S_OK )	return 1;
	else	return 0;
}

int ResumeDirectShowCap( strDirectShowCap *dsc )
// DirectShowɂUSBJ̎gpĊJ
{
	HRESULT hr;
	
	hr = dsc->pMC -> Run();
	if ( hr == S_OK )	return 1;
	else	return 0;
}

int StopDirectShowCap( strDirectShowCap *dsc )
// DirectShowɂUSBJ̎gp~
{
	HRESULT hr;
	
	hr = dsc->pMC -> Stop();
	dsc->pGrab -> SetBufferSamples( 0 );
	if ( hr == S_OK )	return 1;
	else	return 0;
}

void ReleaseDirectShowCap( strDirectShowCap *dsc )
// DirectShowɂUSBJ̎gp̏X
{
	// ---- I ----
	// C^[tF[X̃[X
	dsc->pMC -> Release();
	dsc->pDevEnum -> Release();
	dsc->pGraph -> Release();
	dsc->pCapture -> Release();
	// COM̃[X
	CoUninitialize();
}
