#define	OPENCV

#include <stdio.h>
#ifdef	OPENCV
#include <cv.h>			// OpneCV
#include <highgui.h>	// OpenCV
#endif
#include <windows.h>	// Windows
#include <mmsystem.h>	// Windows
#include <conio.h>	// DirectShow
#include <qedit.h>	// DirectShow
#include <dshow.h>	// DirectShow
#include "dscap.h"

#define	kSaveFileName	"capture.bmp"	/* sL[Ƃɕۑt@C */

#ifdef	OPENCV
void Buff2ImageData( unsigned char *buff, IplImage *img )
// obt@OpenCV̉摜f[^ɕϊ
{
	int i;

	for ( i = 0; i < img->height; i++ ) {
		memcpy( &(img->imageData[img->widthStep*(img->height - i - 1)]), &(buff[img->width*3*i]), img->width*3 );
	}
}
#endif

int main( int argc, char *argv[] )
// WebJTv
{
	int ret, width, height, camconf = 0, paused = -1, key;
	long buff_size;	// obt@̃TCY
	unsigned char *img_buff;	// Lv`f[^̃obt@
#ifdef	OPENCV
	IplImage *img_cap;	// OpenCVŎg߂̉摜f[^
	CvSize img_size;	// 摜̃TCYiCj
#endif
	strDirectShowCap dsc;	// DirectShowŃJgۂ̏X

	// 
	if ( argc > 1 ) {
		if ( strcmp( argv[1], "-a" ) == 0 ) {
			CheckDirectShowCap();	// J̐ݒ`FbN
			return 0;
		}
		else if ( strcmp( argv[1], "-c" ) == 0 && argc > 2 ) {
			camconf = atoi( argv[2] );	// J̃[hw
		}
		else {
			fprintf( stderr, "-a : Check camera data\n-c [Configure number] : Set camera configuration\n" );
			return 1;
		}
	}
	// 
	ret = InitDirectShowCap( camconf, &dsc, &width, &height );	// USBJ
	if ( ret == 0 )	return 1;	// Ɏs
	buff_size = width * height * 3;	// obt@̃TCY߂
	img_buff = (unsigned char *)malloc( buff_size );	// 摜̃obt@m
#ifdef	OPENCV
	img_size.width = width;
	img_size.height = height;
	img_cap = cvCreateImage( img_size, IPL_DEPTH_8U, 3 );	// 摜쐬
	cvNamedWindow( "Capture", CV_WINDOW_AUTOSIZE );	// EBhE쐬
#endif
	StartDirectShowCap( &dsc );	// Lv`Jn
	printf("s : Save frame image\np : Pause\nq : Quit\n");
	/********** [v **********/
	for ( ; ; ) {
		if ( paused < 0 ) {	// |[YĂȂ
			// Lv`
			CaptureDirectShowCap( &dsc, img_buff, buff_size );
#ifdef	OPENCV
			// obt@摜ɕϊ
			Buff2ImageData( img_buff, img_cap );
			// \
			cvShowImage( "Capture", img_cap );
#endif
		}
#ifdef	OPENCV
		key = cvWaitKey( 1 );	// L[͂擾iȂƃEBhEXVȂj
#else
		if ( _kbhit() )	key = getch();
		else	key = -1;
#endif
		if ( key >= 0 ) {
			switch ( key ) {
				case 's':	// ݂̃t[摜t@Cɕۑ
#ifdef	OPENCV
					cvSaveImage( kSaveFileName, img_cap );
#endif
					break;
				case 'p':	// ꎞ~
					if ( paused < 0 ) // |[YĂȂ
						PauseDirectShowCap( &dsc );	// |[Y
					else
						ResumeDirectShowCap( &dsc );	// ĊJ
					paused *= -1;
					break;
				case 'q':	// I
					goto end_cap;
			}
		}

	}
	/********** [v **********/
end_cap:
	StopDirectShowCap( &dsc );	// Lv`I
	ReleaseDirectShowCap( &dsc );	// DirectShow̏X[X
#ifdef	OPENCV
	cvDestroyWindow( "Capture" );	// EBhEj
	cvReleaseImage( &img_cap );	// 摜f[^
#endif
	free( img_buff );	// obt@

	return 0;
}
